

if (SpeakEasyGUI) then return; end




SpeakEasyGUI = {};




SpeakEasyGUI_CategoryDropDownTitle:SetText("Speech category:");
SpeakEasyGUI_ActionDropDownTitle:SetText("Name of action:");
SpeakEasyGUI_EntryDropDownTitle:SetText("Entry number:");


SpeakEasyGUI_DisallowRepeatCheckboxText:SetText("Check to prevent this entry from being randomly selected and sent more than once in a row.");
SpeakEasyGUI_SendAtStartCheckboxText:SetText("Check to have this entry be sent at the start of the cast instead of at the end.");
SpeakEasyGUI_MessageEditBoxTitle:SetText("Message:");
SpeakEasyGUI_MinRandomEditBoxTitle:SetText("Minimum number:");
SpeakEasyGUI_MaxRandomEditBoxTitle:SetText("Maximum number:");
SpeakEasyGUI_MessageTypeDropDownTitle:SetText("Message type:");
SpeakEasyGUI_ChannelOrWhisperEditBoxTitle:SetText("Channel name\nor whisper/emote target:");
SpeakEasyGUI_TimeDelayEditBoxTitle:SetText("Time delay:");
SpeakEasyGUI_LanguageDropDownTitle:SetText("Language:");


SpeakEasyGUI_ClearEntryButton:SetText("Clear Entry");
SpeakEasyGUI_SaveChangesButton:SetText("Save Changes");
SpeakEasyGUI_CloseWindowButton:SetText("Close Window");




BINDING_HEADER_SPEAKEASYGUI = ("SpeakEasyGUI");


do
	local setglobal = setglobal;
	local stringformat = string.format;
	
	for index = 1, 30 do
		setglobal("BINDING_NAME_SPEAKEASYGUI_HOTKEY"..index, stringformat("Activate hotkey entry #%d", index));
	end
end




SpeakEasyGUI.LOCALIZATION = {
	
	
	MESSAGETYPE_EMOTE_BASIC = ("Emote (Basic)");
	MESSAGETYPE_EMOTE_CUSTOM = ("Emote (Custom)");
	MESSAGETYPE_CHANNEL = ("Channel");
	
	
	
	CATEGORY_HOTKEYS = ("Hotkeys");
	CATEGORY_COMBAT_EVENTS = ("Combat Events");
	CATEGORY_MISC_EVENTS = ("Misc. Events");
	CATEGORY_SELF_BUFFS = ("Self Buffs");
	CATEGORY_SELF_DEBUFFS = ("Self Debuffs");
	CATEGORY_ERRATA_NUM = ("Errata %d");
	CATEGORY_ERRATA_NUM_TO_NUM = ("Errata %d - %d");
	
	
	
	SLASH_SPEAK = ("speak");
	SLASH_SPELLDETECT = ("spelldetect");
	SLASH_SELFBUFF = ("selfbuff");
	SLASH_SELFDEBUFF = ("selfdebuff");
	SLASH_SILENCE = ("silence");
	
	
	SPELLDETECT_ENABLED = ("SpeakEasyGUI: Now displaying the name of every spell you cast. Type \"/segui spelldetect\" again to disable this behaviour.");
	SPELLDETECT_DISABLED = ("SpeakEasyGUI: No longer displaying the name of every spell you cast.");
	
	ADDED_SELFBUFF = ("SpeakEasyGUI: Added text \"%s\" to the list of watched self buff combat messages.");
	REMOVED_SELFBUFF = ("SpeakEasyGUI: Removed text \"%s\" from the list of watched self buff combat messages.");
	
	ADDED_SELFDEBUFF = ("SpeakEasyGUI: Added text \"%s\" to the list of watched self debuff combat messages.");
	REMOVED_SELFDEBUFF = ("SpeakEasyGUI: Removed text \"%s\" from the list of watched self debuff combat messages.");
	
	SILENCE_ENABLED = ("SpeakEasyGUI: Your speech entries will no longer be sent under any circumstance. Type \"/segui silence\" again to re-enable them.");
	SILENCE_DISABLED = ("SpeakEasyGUI: Your speech entries will now once again be sent when valid.");
	
	
	COMMANDS_HELP_1 = ("SpeakEasyGUI Commands:");
	COMMANDS_HELP_2 = ("\"speak [number]\" - Activate SpeakEasyGUI's global hotkey action corresponding to [number], where [number] is any integer from 1 to 30.");
	COMMANDS_HELP_3 = ("\"spelldetect\" - Toggle spell name detection mode. When enabled, the name of every spell that you cast (in particular, spells from places you might not expect, like items or world objects) will be printed to the default chat frame.");
	COMMANDS_HELP_4 = ("\"selfbuff [buff name]\" - Substitute [buff name] for the name of a self-buff (which normally appears in the combat log as \""..AURAADDEDSELFHELPFUL:format("[buff name]").."\") to add (or remove) that text to (or from) SpeakEasyGUI's list of monitored self-buff combat messages. Monitored self-buffs appear in the \"Self Buffs\" speech category on the configuration screen.");
	COMMANDS_HELP_5 = ("\"selfdebuff [debuff name]\" - Substitute [debuff name] for the name of a self-debuff (which normally appears in the combat log as \""..AURAADDEDSELFHARMFUL:format("[debuff name]").."\") to add (or remove) that text to (or from) SpeakEasyGUI's list of monitored self-debuff combat messages. Monitored self-buffs appear in the \"Self Debuffs\" speech category on the configuration screen.");
	COMMANDS_HELP_6 = ("\"silence\" - Toggles whether or not your speech entries will be activated under any cirumstance.");
	
	
	
	COMBAT_EVENTS_LIST = {
		YOU_HIT = ("You hit an enemy"); -- CHAT_MSG_COMBAT_SELF_HITS
		YOU_MISS = ("Your attack is negated"); -- CHAT_MSG_COMBAT_SELF_MISSES
		HEAL_HEALS = ("You heal an ally"); -- CHAT_MSG_SELF_BUFF
		ENEMY_HIT = ("An enemy hits you"); -- CHAT_MSG_COMBAT_CREATURE_VS_SELF_HITS
		ENEMY_MISS = ("An enemy's attack is negated"); -- CHAT_MSG_COMBAT_CREATURE_VS_SELF_MISSES
		KILLING_BLOW = ("You deal a killing blow"); -- CHAT_MSG_COMBAT_HOSTILE_DEATH
		ENTER_COMBAT = ("You enter combat"); -- PLAYER_REGEN_DISABLED
		LEAVE_COMBAT = ("You leave combat"); -- PLAYER_REGEN_ENABLED
	};
	
	
	MISC_EVENTS_LIST = {
		TRADE_OPENED = ("Trade window is opened"); -- TRADE_SHOW
		PLAYER_RESURRECTION = ("You resurrect"); -- PLAYER_UNGHOST
		PLAYER_BELOW_TWENTY_HEALTH = ("Your health goes below 20%"); -- UNIT_HEALTH
		PLAYER_BELOW_TWENTY_MANA = ("Your mana goes below 20%"); -- UNIT_MANA
		RELOAD_UI = ("You reload the UI"); -- ReloadUI()
	};
	
	
	
	MISC_EDIT_BOXES_TITLE = ("If a random %d-%d roll falls between the min and max numbers of this entry, its message will be sent.");
	
	
	
	PARSE_SELFBUFF = ("^"..AURAADDEDSELFHELPFUL:gsub("%%s", ".+").."$");
	PARSE_SELFDEBUFF = ("^"..AURAADDEDSELFHARMFUL:gsub("%%s", ".+").."$");
	
	PARSE_KILLING_BLOW = ("^"..SELFKILLOTHER:gsub("%%s", ".+").."$");
	
	
	
	FEEDBACK_ENTRY_MESSAGE_PROMPT = ("<Please fill in the details for this entry now!>");
	FEEDBACK_BASIC_EMOTE_MESSAGEBOX_HELP = ("<Please type the name of a basic emote into this box!>");
	FEEDBACK_ENTRY_CLEARED = ("SpeakEasyGUI: Entry number %d of action \"%s\" in speech category \"%s\" has been cleared.");
	FEEDBACK_SPELL_DETECT = ("SpeakEasyGUI: SpellDetect just received spell \"%s\" from event \"%s\".");
	
	
	
	HOTKEY_NUMBER = ("Hotkey %d");
	HOTKEY_MACRO_TIP = ("Tip: You can trigger this hotkey action from a macro\nby placing the following text within the macro:\n\n/script SpeakEasyGUI:Main_SpeakByGlobalNumber(%d)\n\nOr, to conserve space, try this instead:\n\n/script SEGUI(%d)");
	HOTKEY_BLANK_ENTRY = ("SpeakEasyGUI: This hotkey action (number %d) has no entries, so no messages can be sent.");
	HOTKEY_INVALID_ARGUMENT = ("SpeakEasyGUI: An invalid hotkey number was passed to the hotkey activation function from a macro. An integer from 1 to 2000 was expected, but a \"%s\"-type argument of value \"%s\" was received.");
	
	
	
	ERROR_MESSAGE_BOX = ("SpeakEasyGUI: Error: The message edit box contains no valid text.");
	ERROR_MIN_NUMBER_BOX = ("SpeakEasyGUI: Error: The minimum number edit box's value is either below %d, above %d, or greater than the number in the maximum number edit box.");
	ERROR_MAX_NUMBER_BOX = ("SpeakEasyGUI: Error: The maximum number edit box's value is either below %d, above %d, or lesser than the number in the minimum number edit box.");
	ERROR_TIME_DELAY_BOX = ("SpeakEasyGUI: Error: The time delay's edit box's value is either below %d, above %d, or not a valid integer.");
	ERROR_CHANNEL_OR_WHISPER_BOX = ("SpeakEasyGUI: Error: The channel name or whisper target edit box requires a value when message type is set to \"Channel\" or \""..CHAT_MSG_WHISPER_INFORM.."\".");
	ERROR_INVALID_BASIC_EMOTE = ("SpeakEasyGUI: Error: The text in the message edit box does not correspond to any known basic emote. Try typing a number a number from 1 to %d into the box instead, and then clicking \"Apply Changes\" to see which basic emote corresponds to that number.");
	
	
};

