

local SpeakEasyGUI = SpeakEasyGUI;




do
	local setWidth = UIDropDownMenu_SetWidth;
	
	
	setWidth(125, SpeakEasyGUI_CategoryDropDown);
	SpeakEasyGUI_CategoryDropDownText:SetJustifyH("CENTER");
	
	setWidth(200, SpeakEasyGUI_ActionDropDown);
	SpeakEasyGUI_ActionDropDownText:SetJustifyH("CENTER");
	
	setWidth(50, SpeakEasyGUI_EntryDropDown);
	SpeakEasyGUI_EntryDropDownText:SetJustifyH("CENTER");
	
	
	setWidth(120, SpeakEasyGUI_MessageTypeDropDown);
	SpeakEasyGUI_MessageTypeDropDownText:SetJustifyH("CENTER");
	
	setWidth(100, SpeakEasyGUI_LanguageDropDown);
	SpeakEasyGUI_LanguageDropDownText:SetJustifyH("CENTER");
end



SpeakEasyGUI_MinRandomEditBox:SetNumeric(true);

SpeakEasyGUI_MaxRandomEditBox:SetNumeric(true);


SpeakEasyGUI_TimeDelayEditBox:SetNumeric(true);



SpeakEasyGUI.Original_ReloadUI = ReloadUI;



SpeakEasyGUI.DISPLAY_FRAME:RegisterEvent("VARIABLES_LOADED");




function SpeakEasyGUI:Main_SlashCommandHandler(msg)
	if (not msg or self.STRING_LIBRARY.len(msg) <= 3) then
		self:Config_ToggleDisplay();
		return;
	end
	
	
	local command, argument = msg:match("([^%s]+) (.+)");
	command = (command or msg):lower();
	
	local localization = self.LOCALIZATION;
	
	
	if (command == localization.SLASH_SPEAK) then
		self:Main_SpeakByGlobalNumber(argument);
		
		
	elseif (command == localization.SLASH_SPELLDETECT) then
		if (self.SpellDetectEnabled ~= nil) then
			self.SpellDetectEnabled = nil;
			DEFAULT_CHAT_FRAME:AddMessage(localization.SPELLDETECT_DISABLED, 0.0, 0.8, 1.0);
		else
			self.SpellDetectEnabled = true;
			DEFAULT_CHAT_FRAME:AddMessage(localization.SPELLDETECT_ENABLED, 0.0, 0.8, 1.0);
		end
		
		
	elseif (command == localization.SLASH_SELFBUFF) then
		if (argument) then
			if (self.LocalConfig.SelfBuffs[argument] ~= nil) then
				self:SpecialEntries_RemoveSelfBuff(argument);
				DEFAULT_CHAT_FRAME:AddMessage(localization.REMOVED_SELFBUFF:format(argument), 0.0, 0.8, 1.0);
				
			else
				self:SpecialEntries_AddSelfBuff(argument);
				DEFAULT_CHAT_FRAME:AddMessage(localization.ADDED_SELFBUFF:format(argument), 0.0, 0.8, 1.0);
			end
		end
		
		
	elseif (command == localization.SLASH_SELFDEBUFF) then
		if (argument ~= nil) then
			if (self.LocalConfig.SelfDebuffs[argument] ~= nil) then
				self:SpecialEntries_RemoveSelfDebuff(argument);
				DEFAULT_CHAT_FRAME:AddMessage(localization.REMOVED_SELFDEBUFF:format(argument), 0.0, 0.8, 1.0);
				
			else
				self:SpecialEntries_AddSelfDebuff(argument);
				DEFAULT_CHAT_FRAME:AddMessage(localization.ADDED_SELFDEBUFF:format(argument), 0.0, 0.8, 1.0);
			end
		end
		
		
	elseif (command == localization.SLASH_SILENCE) then
		if (self.LocalConfig.Silence ~= nil) then
			self.LocalConfig.Silence = nil;
			DEFAULT_CHAT_FRAME:AddMessage(localization.SILENCE_DISABLED, 0.0, 0.8, 1.0);
		else
			self.LocalConfig.Silence = true;
			DEFAULT_CHAT_FRAME:AddMessage(localization.SILENCE_ENABLED, 0.0, 0.8, 1.0);
		end
		
		
	else
		local chatFrame = DEFAULT_CHAT_FRAME;
		local addMessage = chatFrame.AddMessage;
		
		for index = 1, 6 do
			addMessage(chatFrame, localization["COMMANDS_HELP_"..index], 0.0, 0.8, 1.0);
		end
	end
end



SlashCmdList["SPEAKEASYGUI"] = (function(msg) SpeakEasyGUI:Main_SlashCommandHandler(msg) end);

SLASH_SPEAKEASYGUI1 = ("/segui");




function SpeakEasyGUI:Main_OnEvent(event, arg1, arg2)
	local action = nil;
	
	
	if (event:sub(1, 4) == "CHAT") then
		if (event == "CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE") then
			action = self:SpecialEntries_GetActionFromBuffDebuffText(arg1, self.LOCALIZATION.PARSE_SELFDEBUFF, self.LocalConfig.SelfDebuffs);
			
		elseif (event == "CHAT_MSG_SPELL_PERIODIC_SELF_BUFFS") then
			action = self:SpecialEntries_GetActionFromBuffDebuffText(arg1, self.LOCALIZATION.PARSE_SELFBUFF, self.LocalConfig.SelfBuffs);
			
		elseif (event == "CHAT_MSG_COMBAT_HOSTILE_DEATH") then
			if (arg1:match(self.LOCALIZATION.PARSE_KILLING_BLOW) ~= nil) then
				action = self.LocalConfig.CombatEvents["KILLING_BLOW"];
			end
			
		else
			action = self:SpecialEntries_GetCombatActionForChatEvent(event);
		end
		
		
	elseif (event == "UNIT_HEALTH") then
		if (arg1 == "player") then
			action = self:SpecialEntries_CheckPlayerHealthPercentage();
		end
		
		
	elseif (event == "UNIT_MANA") then
		if (arg1 == "player" and UnitPowerType("player") == 0) then
			action = self:SpecialEntries_CheckPlayerManaPercentage();
		end
		
		
	elseif (event == "PLAYER_REGEN_DISABLED") then
		action = self.LocalConfig.CombatEvents["ENTER_COMBAT"];
		
		
	elseif (event == "PLAYER_REGEN_ENABLED") then
		action = self.LocalConfig.CombatEvents["LEAVE_COMBAT"];
		
		
	elseif (event == "UNIT_SPELLCAST_SENT") then
		if (self.SpellDetectEnabled ~= nil) then
			DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.FEEDBACK_SPELL_DETECT:format(arg2, event), 0.0, 0.8, 1.0);
		end
		
		-- Parse things like "Create Healthstone (Greater)" as simply "Create Healthstone".
		local startLoc = (arg2 or ""):match("()%s%(.+%)$");
		
		if (startLoc ~= nil) then
			arg2 = arg2:sub(1, (startLoc - 1));
		end
		
		self:Main_ValidateSpellAndAddToErrata(arg2);
		
		local action = self.LocalConfig[arg2];
		if (action ~= nil) then
			self:Speech_ActivateValidEntriesForAction(action, true);
		end
		
		
	elseif (event == "UNIT_SPELLCAST_SUCCEEDED") then
		if (self.SpellDetectEnabled ~= nil) then
			DEFAULT_CHAT_FRAME:AddMessage(self.LOCALIZATION.FEEDBACK_SPELL_DETECT:format(arg2, event), 0.0, 0.8, 1.0);
		end
		
		-- Parse things like "Create Healthstone (Greater)" as simply "Create Healthstone".
		local startLoc = (arg2 or ""):match("()%s%(.+%)$");
		
		if (startLoc ~= nil) then
			arg2 = arg2:sub(1, (startLoc - 1));
		end
		
		self:Main_ValidateSpellAndAddToErrata(arg2);
		
		action = self.LocalConfig[arg2];
		
		
	elseif (event == "TRADE_SHOW") then
		action = self.LocalConfig.MiscEvents["TRADE_OPENED"];
		
		
	elseif (event == "PLAYER_UNGHOST") then
		action = self:SpecialEntries_CheckPlayerResurrectionState();
		
		
	elseif (event == "PLAYER_ENTERING_WORLD" or event == "LEARNED_SPELL_IN_TAB") then
		self:Config_PopulateDisplayTable();
		
		
	elseif (event == "VARIABLES_LOADED") then
		self:Main_InitializeConfig();
		self:SpecialEntries_ManageEventRegistration();
		self:Config_PopulateDisplayTable();
	end
	
	
	if (action ~= nil) then
		self:Speech_ActivateValidEntriesForAction(action, nil);
	end
end


SpeakEasyGUI_DisplayFrame:SetScript("OnEvent", (function(self, event, arg1, arg2, ...) self.SPEAKEASYGUI:Main_OnEvent(event, arg1, arg2); end));




function SpeakEasyGUI:Main_ValidateSpellAndAddToErrata(inputName)
	if (self.SpellErrata[inputName] ~= nil) then return nil; end
	
	
	local speechCategories = self.SpeechCategories;
	local numEntries = #speechCategories;
	local pairs = pairs;
	
	for index = numEntries, (numEntries - (GetNumSpellTabs() - 1)), -1 do
		for spellIndex, spellName in pairs(speechCategories[index].subList) do
			if (inputName == spellName) then
				return nil;
			end
		end
	end
	
	
	self.SpellErrata[inputName] = true;
	
	
	self:Config_PopulateDisplayTable();
end




function SpeakEasyGUI:Main_GetReusableTable(tableNum)
	if (tableNum == nil) then tableNum = 1; end
	
	local reusableTable = self["ReusableTable"..tableNum];
	
	
	if (reusableTable == nil) then
		reusableTable = {};
		self["ReusableTable"..tableNum] = reusableTable;
		
	else
		for key in pairs(reusableTable) do
			reusableTable[key] = nil;
		end
	end
	
	
	return reusableTable;
end




function SpeakEasyGUI:Main_InitializeConfig()
	if (SpeakEasyGUI_GlobalConfig == nil) then
		SpeakEasyGUI_GlobalConfig = {
			Version = self.VERSION;
			SpellErrata = {};
		};
	end
	
	local config = SpeakEasyGUI_GlobalConfig;
	self.GlobalConfig = config;
	
	if (config.SpellErrata == nil) then
		config.SpellErrata = {};
	end
	
	self.SpellErrata = config.SpellErrata;
	
	if (config.Version < 300) then
		self:DataConversion_GlobalConfig_From2xxTo300(config);
	end
	
	config.Version = self.VERSION;
	
	
	if (SpeakEasyGUI_Config == nil) then
		SpeakEasyGUI_Config = {
			Version = self.VERSION;
			Silence = nil;
			CombatEvents = {};
			MiscEvents = {};
			SelfBuffs = {};
			SelfDebuffs = {};
		};
	end
	
	config = SpeakEasyGUI_Config;
	self.LocalConfig = config;
	
	if (config.CombatEvents == nil) then config.CombatEvents = {}; end
	if (config.MiscEvents == nil) then config.MiscEvents = {}; end
	if (config.SelfBuffs == nil) then config.SelfBuffs = {}; end
	if (config.SelfDebuffs == nil) then config.SelfDebuffs = {}; end
	
	if (config.Version < 300) then
		self:DataConversion_LocalConfig_From2xxTo300(config);
	end
	
	config.Version = self.VERSION;
end

